#include <DFRobot_ID809.h>
#include <Servo.h>
#include <avr/sleep.h>

DFRobot_ID809 fingerprint;
Servo myservo;

void setup(){
  pinMode(13, OUTPUT);
  pinMode(11, OUTPUT);
  pinMode(3, INPUT);
  digitalWrite(11,HIGH);
  /*初始化FPSerial*/
  Serial1.begin(115200);
  /*将FPSerial作为指纹模块的通讯串口*/
  fingerprint.begin(Serial1);
  while(fingerprint.isConnected() == false){
    digitalWrite(13,HIGH);
    delay(500);
    digitalWrite(13,LOW);
    delay(500);
  }
  myservo.attach(9);
  myservo.write(10);
  /*!
   *@brief Set avr sleep mode
   */
  set_sleep_mode (SLEEP_MODE_PWR_DOWN);
}

uint8_t ret = 0;
long long nowTime = 0;

void loop(){
  //如果有手指按下
  if(digitalRead(3)){
    fingerprint.collectionFingerprint(/*timeout=*/2);
    ret = fingerprint.search();
    if(ret != 0){   //指纹验证成功
      //绿色灯快闪2次
      fingerprint.ctrlLED(fingerprint.eFastBlink, fingerprint.eLEDGreen, 2);
      //开锁控制舵机
      myservo.write(170);
      //延时2秒方便开门
      delay(2000);
      //舵机复原
      myservo.write(10);
    }else{  //指纹验证失败
      //红色灯快闪2次
      fingerprint.ctrlLED(fingerprint.eFastBlink, fingerprint.eLEDRed, 2);
    }
    //记录时间
    nowTime = millis();
  }
  //5秒后进入休眠
  if((millis()-nowTime) > 5000){
    //打开引脚中断，用于唤醒主控
    attachInterrupt(0, interrupt, RISING);  
    //拉低WAKE,关闭指纹模块
    digitalWrite(11,LOW);
    //使能休眠
    sleep_enable();
    //进入休眠
    sleep_cpu();
    /***********退出休眠由此处开始执行****************/
    //失能休眠
    sleep_disable();
    //拉高WAKE,打开指纹模块
    digitalWrite(11,HIGH);
    //关闭引脚中断
    detachInterrupt(digitalPinToInterrupt(3));
    delay(200);
  }
}

//中断服务函数
void interrupt(){
  
}